unit IsoChartHolesTest_u;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TeEngine, TeeSurfa, ExtCtrls, TeeProcs, Chart,
  TeeTools;

type
  TForm1 = class(TForm)
    Chart1: TChart;
    MyIsoSeries: TIsoSurfaceSeries;
    ChartTool1: TRotateTool;
    MyContourSeries: TContourSeries;
    Panel1: TPanel;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  procedure PlotIsoSeries;
  procedure PlotContourSeries;

implementation

{$R *.dfm}
{______________________________________________________________________________}

procedure TForm1.Button1Click(Sender: TObject);
begin
case RadioGroup1.ItemIndex of
  0 : PlotIsoSeries;
  1 : PlotContourSeries;
  end;
end;
{______________________________________________________________________________}

procedure PlotIsoSeries;
var
T : textFile;
i : integer;
S : String;
X : Integer;
Y : Real;
Z : Integer;
begin
with Form1 do
  begin
  MyIsoSeries.Clear;
  MyContourSeries.Clear;

  MyIsoSeries.Visible := True;
  MyContourSeries.Visible := False;

  MyIsoSeries.FastBrush := False;
  Chart1.LeftAxis.Automatic := True;
  Chart1.LeftAxis.AutomaticMaximum := True;
  Chart1.LeftAxis.AutomaticMinimum := True;
  Chart1.BottomAxis.Minimum := 0.0;
  Chart1.BottomAxis.Maximum := 24.0;
  MyIsoSeries.UseColorRange := False;
  MyIsoSeries.UsePalette := True;

  if not FileExists('IsoTestData.txt') then
    begin
    MessageDlg('Cannot find test data ''IsoTestData.txt''', mtError, [mbOK], 0);
    exit;
    end;
  Memo1.Lines.Clear;
  Memo1.Lines.Add('X,  Y,  Z');
  AssignFile(T, 'IsoTestData.txt');
  Reset(T);
   While not EOF(T) do
     begin
     ReadLn(T, S);
     memo1.Lines.Add(S);
     X := StrToIntDef(copy(S, 1, Pos(',', S)-1), 0);
     S := copy(S, pos(',', S)+1, Length(S));

     Y := StrToFloatDef(copy(S, 1, Pos(',', S)-1), 0);
     S := copy(S, pos(',', S)+1, Length(S));

     Z := StrToIntDef(S, 0);
     MyIsoSeries.addxyz(X, Y, Z);

     end;
   CloseFile(T);
   end; {with}
end; {procedure}
{______________________________________________________________________________}

procedure PlotContourSeries;
var
T : textFile;
i : integer;
S : String;
X : Integer;
Y : Real;
Z : Integer;
begin
with Form1 do
  begin
  MyIsoSeries.Clear;
  MyContourSeries.Clear;

  MyContourSeries.Visible := True;
  MyIsoSeries.Visible := False;

  MyIsoSeries.FastBrush := False;
  MyContourSeries.UseColorRange := False;
  MyContourSeries.UsePalette := True;

  Chart1.LeftAxis.AutomaticMaximum := True;
  Chart1.LeftAxis.AutomaticMinimum := True;

  Chart1.LeftAxis.Automatic := False;
  Chart1.LeftAxis.Minimum := 0.0;
  Chart1.LeftAxis.Maximum := 120.0;
  MyContourSeries.YPositionLevel := True;
  MyContourSeries.Brush.Style := bsSolid;

  if not FileExists('ContourTestData.txt') then
    begin
    MessageDlg('Cannot find test data ''ContourTestData.txt''', mtError, [mbOK], 0);
    exit;
    end;
  Memo1.Lines.Clear;
  Memo1.Lines.Add('X,  Y,  Z');

  AssignFile(T, 'ContourTestData.txt');
  Reset(T);
   While not EOF(T) do
     begin
     ReadLn(T, S);
     memo1.Lines.Add(S);
     X := StrToIntDef(copy(S, 1, Pos(',', S)-1), 0);
     S := copy(S, pos(',', S)+1, Length(S));

     Y := StrToFloatDef(copy(S, 1, Pos(',', S)-1), 0);
     S := copy(S, pos(',', S)+1, Length(S));

     Z := StrToIntDef(S, 0);
     MyContourSeries.addxyz(X, Y, Z);

     end;
   CloseFile(T);
   end; {with}
end; {procedure}
{______________________________________________________________________________}

end.
